<?php
use Joomla\Component\Jshopping\Site\Lib\UploadFile;
defined('_JEXEC') or die('Restricted access');

class plgJshoppingAdminAddon_Order_Email_Payment_Attachement extends JPlugin{
	
    public function onBeforeEditPayments(&$view){
        \JFactory::getDocument()->addScriptDeclaration('jQuery(document).ready(function(){jQuery("#adminForm").attr("enctype", "multipart/form-data");});');
        list($attachement_upload_name, $attachement_filename) = explode('|', $view->payment->order_email_attachement);
        $view->etemplatevar .= '<tr>'.
                                   '<td class="key" valign="top">'.\JText::_('JSHOPPING_ADDON_ORDER_EMAIL_PAYMENT_ATTACHEMENT_FIELD_TITLE').'</td>'.
                                   '<td>'.
                                       '<input name="order_email_attachement" type="file" value="'.$attachement_upload_name.'" />'.
                                       ($view->payment->order_email_attachement != '' ? '<br/><small><a href="'.JSAddon_Order_Email_Payment_Attachement_Helper::getUploadedFileURI($attachement_upload_name).'" target="_blank">'.$attachement_filename.'</a>'.
                                                                    '&nbsp;&nbsp;<input type="checkbox" name="delete_order_email_attachement" id="delete_order_email_attachement" value="1" />&nbsp;&nbsp;<label for="delete_order_email_attachement" style="font-size:inherit">'.\JText::_('JSHOP_DELETE').'</label></small>' : '').
                                   '</td>'.
                               '</tr>';
    }
    
    public function onBeforeSavePayment(&$post){
        $payment = \JSFactory::getTable('paymentmethod');
        $payment->load($post['payment_id']);
        list($attachement_upload_name, $attachement_filename) = explode('|', $payment->order_email_attachement);
        if(\JFactory::getApplication()->input->getBool('delete_order_email_attachement')){            
            unlink(JSAddon_Order_Email_Payment_Attachement_Helper::getUploadedFilePath($attachement_upload_name));
            $post['order_email_attachement'] = '';
        }
        
        $upload = new UploadFile($_FILES['order_email_attachement']);
        $upload_filename = $upload->getName();
        $upload->setDir(JSAddon_Order_Email_Payment_Attachement_Helper::getUploadePath());
        $upload->setFileNameMd5(0);
        $upload->setFilterName(1);
        if ($upload->upload()){
            $name = $upload->getName();
            $upload_name = $name;
            $post['order_email_attachement'] = $upload_name.'|'.$upload_filename;

        } else {
            if ($upload->getError() != 4){
                \JFactory::getApplication()->enqueueMessage(\JText::_('JSHOP_ERROR_UPLOADING'), 'notice');
                \JSHelper::saveToLog("error.log", "Error upload payment file. code: ".$upload->getError());
            }
        }
   
    }
}